Subject: [Stox] review: stox-core-04

From: Salvatore Loreto <[email-masked]>
Date: Fri, 20 Sep 2013 12:39:05 +0300

I have reviewed the core-04 draft, and I think that is almost ready for 
the WGLC

I have one general comment
(btw I apologize in advance if this has already been discussed and I 
have overlooked or forgot it)
and it is about the fact that draft does not talk at all about the inter 
working when secure URIs are involved.
I think that at least we should say something about in the Security 
consideration.

* Editorial nits

-In section 6.2, the following sentence

    The codes listed below are limited to those defined in the core SIP
    specification [RFC3261  <http://tools.ietf.org/html/rfc3261>] and in RFCs that formally update [RFC3261  <http://tools.ietf.org/html/rfc3261>].

It suggests, at least to me, that in the list below are listed all the 
codes defined
in 3261 and in RFC that formally update 3261, but this is not the case.

-first paragraph section 5.1
     s/spports/supports

Cheers
Salvatore

-- 
Salvatore Loreto, PhD
www.sloreto.com

---

From: Salvatore Loreto <[email-masked]>
Date: Fri, 20 Sep 2013 13:42:24 +0300

my only comments is about the fact that section 3. XMPP to SIP
implies that the MESSAGE is always (and maybe can only be) delivered 
over a TCP connection;
RFC3428 states

    Whenever possible, MESSAGE requests SHOULD be sent over transports
    that implement end-to-end congestion control, such as TCP or SCTP.
    However, SIP does not provide a mechanism to prevent a downstream hop
    from sending a request over UDP.

so you can delivery it over UDP as well and that has also being raised 
in a previous thread
while talking on the Call-ID mapping to <thread/>.
Actually you will be forced to deliver over UDP if the SIMPLE server 
only supports UDP.

So I would suggest to change

    Here we assume that the XMPP server has
    determined the foreign domain is serviced by a SIMPLE server,

in

    Here we assume that the XMPP server has
    determined the foreign domain is serviced by a SIMPLE TCP server,

best regards
Salvatore

-- 
Salvatore Loreto, PhD
www.sloreto.com

---

From: Peter Saint-Andre <[email-masked]>
Date: Mon, 23 Sep 2013 17:45:35 -0600

Hi Sal, thanks for the review.

On 9/20/13 4:42 AM, Salvatore Loreto wrote:

> implies that the MESSAGE is always (and maybe can only be)
> delivered over a TCP connection; RFC3428 states
> 
> However, SIP does not provide a mechanism to prevent a downstream
> hop from sending a request over UDP.
> 
> so you can delivery it over UDP as well and that has also being
> raised in a previous thread while talking on the Call-ID mapping to
> <thread/>. Actually you will be forced to deliver over UDP if the
> SIMPLE server only supports UDP.

It's not clear to me why the XMPP-to-SIP gateway couldn't communicate
with the SIMPLE server over UDP. Which text in Section 3 do you think
implies that only TCP connections are supported?

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/

---

From: Peter Saint-Andre <[email-masked]>
Date: Mon, 23 Sep 2013 17:54:34 -0600

On 9/20/13 3:39 AM, Salvatore Loreto wrote:
> I have reviewed the core-04 draft, and I think that is almost ready
> for the WGLC
> 
> I have one general comment (btw I apologize in advance if this has
> already been discussed and I have overlooked or forgot it) and it
> is about the fact that draft does not talk at all about the inter 
> working when secure URIs are involved. I think that at least we
> should say something about in the Security consideration.

Good catch. After reading and re-reading Section 26.4.4 of RFC 3261, I
have to admit that I'm not sure exactly how SIP entities are supposed
to handle SIPS URIs. Even if we understand those requirements, I'm
also not sure how they would apply to the XMPP side of the
communications path. At the least, it seems we'd want to specify that
if the To header or Request-URI is a SIPS URI, then the SIP-to-XMPP
gateway needs to connect to the XMPP server over a TLS-protected
stream. However, do we also need to stipulate that the XMPP
server-to-client connection is TLS-protected? If so, how would the
gateway associated with the XMPP server ensure that? (The gateway
might be an external component of the XMPP server, without control
over how the XMPP server communicates with XMPP clients.)

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/

---

From: Salvatore Loreto <[email-masked]>
Date: Tue, 24 Sep 2013 09:02:57 +0300

On 9/24/13 2:45 AM, Peter Saint-Andre wrote:
> -----BEGIN PGP SIGNED MESSAGE-----
> Hash: SHA1
>
there is not text at all, and that is the problem.
When I read the Section 3 and the example I got the impression that
I can only use TCP to forward the message on the SIP side
but maybe it is only me!

cheers
Salvatore

>
> Peter
>
> - -- 
> Peter Saint-Andre
> https://stpeter.im/
>
>
> -----BEGIN PGP SIGNATURE-----
> Version: GnuPG/MacGPG2 v2.0.19 (Darwin)
> Comment: GPGTools - http://gpgtools.org
> Comment: Using GnuPG with Thunderbird - http://www.enigmail.net/
>
> iQIcBAEBAgAGBQJSQNKeAAoJEOoGpJErxa2p4GsP/i2SppGYjm4g1tOel6+z4G+q
> zmhA+198I9ETLhCGP340z0g/eR/E0mZazti4d/82mMdQuxaAYL4ECCBCcEfWOdi7
> 8jyt1HrGNX73rYI9cF4PN7b07REu4A7KIHzPmHme8RrAceuizkyts7sQtIiNcjoY
> bA+zIduglXWOsYRkIhLPQtT3MX5//wERzdtwjtP0SC9TiuioOXkr0gRQl2rjPY/D
> /kI3fT1XppxMdyaMO7tCkYcgzeXBKpFExpDmFXcKDuVGQfYIwsHsj58iZo9WgGf8
> rJXJhGeUcm4sU4HordkkfcD7h2QKyikoYAcyqyFNdfyW756psG2H/OV2eg4TJ6Zp
> Z9mpcel1QY44CByT6Mzy722JbFl9QYrB1KhjgspuGABZxRcAkKEO+z4prGNuvXHF
> y4c2q1yPaPxJFUQw5IgJUddqo+U7NXpI2w5Jg5Jrb557hPlKPTivIrfrUvCMJVR5
> 0ck1mfrrX6wMQU0vH5cASYYBZgwGtHlqcdVOCNSssl26FIvfaVUvaLW9SkcMR4OD
> EoW18vZ7XvrK6fJ8ec4tMIF6Cng/R1QM/MPpkgBTMBcPGmilAlGB+jBr8GAtwuql
> kzSl91IVZwMI66Fimi/knjaJCwotBdY7jjqa8CYHIvXhsZcma5wSyb37IwP1bTTN
> l+3Dhvz1tB4444evLgcG
> =5aYJ
> -----END PGP SIGNATURE-----

---

From: Peter Saint-Andre <[email-masked]>
Date: Tue, 24 Sep 2013 06:35:37 -0600

On 9/24/13 12:02 AM, Salvatore Loreto wrote:
> On 9/24/13 2:45 AM, Peter Saint-Andre wrote: Hi Sal, thanks for the
> review.
> 
>>>> my only comments is about the fact that section 3. XMPP to
>>>> SIP implies that the MESSAGE is always (and maybe can only
>>>> be) delivered over a TCP connection; RFC3428 states
>>>> 
>>>> Whenever possible, MESSAGE requests SHOULD be sent over
>>>> transports that implement end-to-end congestion control, such
>>>> as TCP or SCTP. However, SIP does not provide a mechanism to
>>>> prevent a downstream hop from sending a request over UDP.
>>>> 
>>>> so you can delivery it over UDP as well and that has also
>>>> being raised in a previous thread while talking on the
>>>> Call-ID mapping to <thread/>. Actually you will be forced to
>>>> deliver over UDP if the SIMPLE server only supports UDP.
> It's not clear to me why the XMPP-to-SIP gateway couldn't
> communicate with the SIMPLE server over UDP. Which text in Section
> 3 do you think implies that only TCP connections are supported?
>> there is not text at all, and that is the problem. When I read
>> the Section 3 and the example I got the impression that I can
>> only use TCP to forward the message on the SIP side but maybe it
>> is only me!

I doubt it is only you. :-)

Because there is no such thing as XMPP over UDP, the gateway from SIP
to XMPP will need to communicate over TCP. However, I see no reason
why the gateway from XMPP to SIP could not be "smart" and send SIP
messages over TCP or UDP depending on what the far SIP server
supports. I'll work to add some clarifying text on these points.

Peter

- -- 
Peter Saint-Andre
https://stpeter.im/